Loading...
Searching...
No Matches
juce::dsp::WindowingFunction< FloatType > Class Template Reference

## Detailed Description

template<typename FloatType>
class juce::dsp::WindowingFunction< FloatType >

A class which provides multiple windowing functions useful for filter design and spectrum analyzers.

The different functions provided here can be used by creating either a WindowingFunction object, or a static function to fill an array with the windowing method samples.

The documentation for this class was generated from the following file:

- juce_dsp/frequency/juce_Windowing.h

## Public Types

enum | WindowingMethod { rectangular = 0 , triangular , hann , hamming , blackman , blackmanHarris , flatTop , kaiser , numWindowingMethods }
| The windowing methods available. More...

## Public Member Functions

| WindowingFunction (size_t size, WindowingMethod, bool normalise=true, FloatType beta=0)
| This constructor automatically fills a buffer of the specified size using the fillWindowingTables function and the specified arguments.
void | fillWindowingTables (size_t size, WindowingMethod type, bool normalise=true, FloatType beta=0) noexcept
| Fills the content of the object array with a given windowing method table.
void | multiplyWithWindowingTable (FloatType *samples, size_t size) const noexcept
| Multiplies the content of a buffer with the given window.

## Static Public Member Functions

static void | fillWindowingTables (FloatType *samples, size_t size, WindowingMethod, bool normalise=true, FloatType beta=0) noexcept
| Fills the content of an array with a given windowing method table.
static const char * | getWindowingMethodName (WindowingMethod) noexcept
| Returns the name of a given windowing method.

## Member Enums

## WindowingMethod

template<typename FloatType>

enum juce::dsp::WindowingFunction::WindowingMethod

The windowing methods available.

Enumerator
rectangular |
triangular |
hann |
hamming |
blackman |
blackmanHarris |
flatTop |
kaiser |
numWindowingMethods |

## Constructors and Destructors

## WindowingFunction()

template<typename FloatType>

juce::dsp::WindowingFunction< FloatType >::WindowingFunction | ( | size_t | size,
|  | WindowingMethod | ,
|  | bool | normalise = true,
|  | FloatType | beta = 0 )

This constructor automatically fills a buffer of the specified size using the fillWindowingTables function and the specified arguments.

See also
  fillWindowingTables

Referenced by getWindowingMethodName().

## Member Functions

## fillWindowingTables() [1/2]

template<typename FloatType>

void juce::dsp::WindowingFunction< FloatType >::fillWindowingTables | ( | size_t | size,
|  | WindowingMethod | type,
|  | bool | normalise = true,
|  | FloatType | beta = 0 )

noexcept

Fills the content of the object array with a given windowing method table.

Parameters

  size | the size of the destination buffer allocated in the object
  type | the type of windowing method being used
  normalise | if the result must be normalised, creating a DC amplitude response of one
  beta | an optional argument useful only for Kaiser's method which must be positive and sets the properties of the method (bandwidth and attenuation increases with beta)

Referenced by fillWindowingTables().

## fillWindowingTables() [2/2]

template<typename FloatType>

void juce::dsp::WindowingFunction< FloatType >::fillWindowingTables | ( | FloatType * | samples,
|  | size_t | size,
|  | WindowingMethod | ,
|  | bool | normalise = true,
|  | FloatType | beta = 0 )

static noexcept

Fills the content of an array with a given windowing method table.

Parameters

  samples | the destination buffer pointer
  size | the size of the destination buffer allocated in the object
  normalise | if the result must be normalised, creating a DC amplitude response of one
  beta | an optional argument useful only for Kaiser's method, which must be positive and sets the properties of the method (bandwidth and attenuation increases with beta)

References fillWindowingTables().

## multiplyWithWindowingTable()

template<typename FloatType>

void juce::dsp::WindowingFunction< FloatType >::multiplyWithWindowingTable | ( | FloatType * | samples,
|  | size_t | size ) const

noexcept

Multiplies the content of a buffer with the given window.

References multiplyWithWindowingTable().

Referenced by multiplyWithWindowingTable().

## getWindowingMethodName()

template<typename FloatType>

const char * juce::dsp::WindowingFunction< FloatType >::getWindowingMethodName | ( | WindowingMethod |  | ) |

static noexcept

Returns the name of a given windowing method.

References getWindowingMethodName(), JUCE_DECLARE_NON_COPYABLE_WITH_LEAK_DETECTOR, and WindowingFunction().

Referenced by getWindowingMethodName().

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited